﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace Falcon.TaskScheduling
{
    /// <summary>
    /// 任务调度器
    /// </summary>
    public interface ITaskScheduler
    {
        /// <summary>
        /// 将任务加入普通任务调度队列
        /// </summary>
        /// <param name="weight">队列序号。序号从0开始到定义的队列总数-1</param>
        /// <param name="task">要加入的任务</param>
        void AddQueue(int weight,ITaskUnit task);
        /// <summary>
        /// 将任务加入系统级队列。如果不允许则抛出异常
        /// </summary>
        /// <param name="task">要加入的任务</param>
        void AddSystemQueue(ITaskUnit task);
        /// <summary>
        /// 将任务加入优先级队列。如果不允许则抛出异常
        /// </summary>
        /// <param name="task">要加入的任务</param>
        void AddFirstQueue(ITaskUnit task);
        /// <summary>
        /// 将任务加入空闲队列。如果不允许则抛出异常
        /// </summary>
        /// <param name="task">要加入的任务</param>
        void AddIdleQueue(ITaskUnit task);
        /// <summary>
        /// 开始执行优先级队列
        /// </summary>
        void Start();
    }
}
