﻿namespace Falcon.TaskScheduling
{
    /// <summary>
    /// 任务调度器参数
    /// </summary>
    public class TaskSchedulerOption
    {
        /// <summary>
        /// 允许系统级任务队列，优先级最高，只要有任务优先调度。
        /// </summary>
        public bool EnableSystemQueue { get; set; } = true;
        /// <summary>
        /// 允许优先任务队列，在系统级队列无任务执行后进行调度。
        /// </summary>
        public bool EnableFirstQueue { get; set; } = true;
        /// <summary>
        /// 允许空闲任务队列，其他队列无任务时调用
        /// </summary>
        public bool EnableIdleQueue { get; set; } = true;
        /// <summary>
        /// 普通优先级任务队列定义。按照提供的整数（调度概率）序列实现队列，数字越大队列调度概率越高
        /// </summary>
        /// <example>例如定义10,5，表示15次调用中第一个队列调度10次，第二个队列5次。</example>
        public string QueueDefine { get; set; } = "2,1";
    }
}
